This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 1305970 - --disable-epsv option ignored for IPv6 hosts
--disable-epsv option ignored for IPv6 hosts
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: curl (Show other bugs)
6.8
Unspecified Unspecified
low Severity low
: rc
: ---
Assigned To: Kamil Dudka
BaseOS QE Security Team
: ManPageChange
Depends On: 1305974
Blocks:
  Show dependency treegraph
 
Reported: 2016-02-09 12:21 EST by Martin Frodl
Modified: 2016-07-13 10:09 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 1305974 (view as bug list)
Environment:
Last Closed: 2016-07-13 10:09:09 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Martin Frodl 2016-02-09 12:21:11 EST
Description of problem:

With --disable-epsv, curl should not attempt to use EPSV mode no matter what. When the host name in URL is 'localhost' or 'localhost.localdomain', EPSV is not disabled. On the other hand, when 127.0.0.1 is used instead, --disable-epsv is respected.

Version-Release number of selected component (if applicable):
curl-7.19.7-51.el6.x86_64

Steps to reproduce:
# yum -y install vsftpd
# echo OK > /var/ftp/pub/test
# service vsftpd start
# curl -v --disable-epsv ftp://localhost/pub/test

Actual results:
> EPSV
* Connect data stream passively
< 229 Entering Extended Passive Mode (|||20246|).
*   Trying 127.0.0.1... connected

Expected results:
> PASV
* Connect data stream passively
< 227 Entering Passive Mode (127,0,0,1,251,224).
*   Trying 127.0.0.1... connected
Comment 2 Eva Mrakova 2016-02-10 02:48:48 EST
Hi,

according to several resources curl option --disable-epsv has no effect for 
IPv6 hosts.
For curl-7.19.7-51.el6 it works OK for localhost4 and also for localhost
together with curl --ipv4 option.

See e.g.
https://curl.haxx.se/libcurl/c/CURLOPT_FTP_USE_EPSV.html
...
If the server is an IPv6 host, this option will have no effect as of 7.12.3
...
Comment 3 Martin Frodl 2016-02-10 03:51:01 EST
Thanks for the explanation. Still, I think this peculiarity should be documented right in curl man page shipped in RHEL at the very least.
Comment 4 Kamil Dudka 2016-02-10 06:52:33 EST
Eva, thank you for replying on this!

I believe the behavior is already documented in the RHEL-6 man page.

$ rpm -q libcurl-devel
libcurl-devel-7.19.7-46.el6.i686

$ man curl_easy_setopt | grep -A8 CURLOPT_FTP_USE_EPSV
       CURLOPT_FTP_USE_EPSV
              Pass  a  long.  If the value is 1, it tells curl to use the EPSV
              command when doing passive FTP downloads (which it  always  does
              by  default). Using EPSV means that it will first attempt to use
              EPSV before using PASV, but if you pass zero to this option,  it
              will not try using EPSV, only plain PASV.

              If  the  server is an IPv6 host, this option will have no effect
              as of 7.12.3.

See also: https://github.com/curl/curl/commit/0966ddaf
Comment 5 Martin Frodl 2016-02-10 07:16:54 EST
I would still argue that a man page provided by a devel subpackage is not the most fortunate place to provide this information. Not for a user who does not give a tinker's cuss about the internal affairs of curl and only cares about the command-line interface and the man page shipped with it.

Obviously, this is a not a high priority bug which ought to be fixed on a short notice. Nonetheless, I believe adding that one sentence to curl man page still does make sense.
Comment 6 Kamil Dudka 2016-02-12 12:52:46 EST
upstream commit:

https://github.com/curl/curl/commit/curl-7_47_1-30-g4ef6b2d
Comment 7 Kamil Dudka 2016-07-13 10:09:09 EDT
RHEL-6 is in Production Phase 2, which means that only critical and security bugs are fixed.  The current documentation is technically correct.  Additional documentation improvements on this topic will be included in RHEL-7.

Note You need to log in before you can comment on or make changes to this bug.